/*
 *
 * Xilinx, Inc.
 * XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS" AS A 
 * COURTESY TO YOU.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION AS
 * ONE POSSIBLE   IMPLEMENTATION OF THIS FEATURE, APPLICATION OR 
 * STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS IMPLEMENTATION 
 * IS FREE FROM ANY CLAIMS OF INFRINGEMENT, AND YOU ARE RESPONSIBLE 
 * FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE FOR YOUR IMPLEMENTATION
 * XILINX EXPRESSLY DISCLAIMS ANY WARRANTY WHATSOEVER WITH RESPECT TO 
 * THE ADEQUACY OF THE IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO 
 * ANY WARRANTIES OR REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE 
 * FROM CLAIMS OF INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY 
 * AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/*
 * Xilinx EDK 8.2.02 EDK_Im_Sp2.4
 *
 * This file is a sample test application
 *
 * This application is intended to test and/or illustrate some 
 * functionality of your system.  The contents of this file may
 * vary depending on the IP in your system and may use existing
 * IP driver functions.  These drivers will be generated in your
 * XPS project when you run the "Generate Libraries" menu item
 * in XPS.
 *
 * Your XPS project directory is at:
 *    C:\memocode_entry\
 */


// Located in: ppc405_0/include/xparameters.h
#include "xparameters.h"

#include "stdio.h"

#include "xutil.h"
#include "ddr_header.h"

//====================================================
/*
 *
 * Xilinx, Inc.
 * XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS" AS A 
 * COURTESY TO YOU.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION AS
 * ONE POSSIBLE   IMPLEMENTATION OF THIS FEATURE, APPLICATION OR 
 * STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS IMPLEMENTATION 
 * IS FREE FROM ANY CLAIMS OF INFRINGEMENT, AND YOU ARE RESPONSIBLE 
 * FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE FOR YOUR IMPLEMENTATION
 * XILINX EXPRESSLY DISCLAIMS ANY WARRANTY WHATSOEVER WITH RESPECT TO 
 * THE ADEQUACY OF THE IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO 
 * ANY WARRANTIES OR REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE 
 * FROM CLAIMS OF INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY 
 * AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/*
 * Xilinx EDK 8.2.02 EDK_Im_Sp2.4
 *
 * This file is a sample test application
 *
 * This application is intended to test and/or illustrate some 
 * functionality of your system.  The contents of this file may
 * vary depending on the IP in your system and may use existing
 * IP driver functions.  These drivers will be generated in your
 * XPS project when you run the "Generate Libraries" menu item
 * in XPS.
 *
 * Your XPS project directory is at:
 *    C:\Xilinx\memocode_entry\
 */


// Located in: ppc405_0/include/xparameters.h
#define MYRON
#undef MURALI

#include "xparameters.h"

#include "stdio.h"

#include "xutil.h"
#include "ddr_header.h"
#include "instructions.h"
#include "cLib.h"
#include "matrixPointers.h"
#include "timer.h" 

//====================================================
typedef signed int Number;
#define WIDTH (16)
#define MASK (0xffff)
#define PACK(r,i) (((r)<<WIDTH)|((i)&MASK))
#define UNPACKR(r) ((r)>>WIDTH)
#define UNPACKI(i) (((i)<<WIDTH)>>WIDTH)

#define OVERFLOW(f) (!((((f)&0xffff8000)==0)||(((f)&0xffff8000)==0xffff8000)))

#ifdef MYRON
static inline Number complexMult(Number A, Number B) {
        // Our interpretation is
	//   B and the return value use the same 2's complement fixed-point format
	//   A uses 2's complement fixed-point format with 1-bit sign, 1-bit integer, 14-bit fraction
	signed int Ar=UNPACKR(A);
	signed int Ai=UNPACKI(A);
	signed int Br=UNPACKR(B);
	signed int Bi=UNPACKI(B);
	Number Cr, Ci;

	Cr=((Ar*Br)>>14)-((Ai*Bi)>>14);
	Ci=((Ar*Bi)>>14)+((Ai*Br)>>14);	

	return PACK(Cr,Ci);
}
#endif

static inline Number absDiff(Number A, Number B) {
  Number ipart = UNPACKI(A) - UNPACKI(B);
  Number rpart = UNPACKR(A) - UNPACKR(B);
  
  Number absDiff = ((ipart < 0) ? -ipart : ipart) +
                   ((rpart < 0) ? -rpart : rpart);
						 
  return absDiff;						 
}


static inline Number complexAdd(Number A, Number B) {
	// A, B and the return value use the same 2's complement fixed-point format
	signed long Ar=UNPACKR(A);
	signed long Ai=UNPACKI(A);
	signed long Br=UNPACKR(B);
	signed long Bi=UNPACKI(B);
	Number Cr, Ci;

	Cr=Ar+Br;
	Ci=Ai+Bi;

	//assert(!OVERFLOW(Cr));
	//assert(!OVERFLOW(Ci));

	return PACK(Cr,Ci);
}

static inline Number complexRandom() {
	Number Cr, Ci;
	//unsigned long x=0;
   //static x;
   static int x = 0;
	
	// no random in EDK stdlib
	
	//Cr=(Number)(rand()%1024)-512;
	//Ci=(Number)(rand()%1024)-512;

	//Cr=(Number)((x+=751)%64)-32;
	//Ci=(Number)((x+=751)%64)-32;

	Cr=(Number)((x+=853)%64)-32;
	Ci=(Number)((x+=751)%63)-32;

	//Cr=(Number)((x)%64-32);
	//Ci=(Number)((x+1)%64-32);

   //x = x + 2;
	
	//Cr=(Number)((x)%64-32);
	//Ci=(Number)((x)%64-32);

   //x = x + 1;	
	
	return PACK(Cr,Ci);
}

// -----------------------------------------------------------------------------

/* Multiplies a [NB x NB] block of two square, row-major order matricies (A, B), 
	where the size of matrix A, B, and C is [N X N]. */

void mmmKernel(Number* A, Number* B, Number* C, int N, int NB) {	
        int i, j, k;
	for (j = 0; j < NB; j++)
	{
      if(j%10==0){xil_printf("Feelin' Slow:%d\n\r", j);};
      for (i = 0; i < NB; i++)
			for (k = 0; k < NB; k++)
				C[i * N + j] = complexAdd( C[i * N + j], complexMult(A[i * N + k], B[k * N + j]) );
				}
}


void mmm(Number* A, Number* B, Number *C, int N) {
	// verify all arguments, sizes of A and B are not checked
	//assert(A != NULL);
	//assert(B != NULL);
	//assert((N > 0) && (N <= 0x4000));
	//assert(C != NULL);
	
	// perform the matrix-matrix multiply on the whole matrix at once
	mmmKernel(A, B, C, N, N);
	
}


int main() {

  int size, log_size, seed, i;
  Number *A, *B, *C, *ours;
  volatile int *program;
  long long start, finish;

#ifdef MYRON  
  size = 64;
 log_size = 6;	  
/* int algo[12] = {0x80000020,0x00000006,
                  0x80000000,0x00000009,
                  0x8000000c,0x00000000,
                  0x8000000d,0x00400000,
                  0x80000000,0x0000000a,
                  0x80000012,0x00800000}; */
#endif

  A = ((Number*)aMatrix);
  B = ((Number*)bMatrix);
  ours = ((Number*)cMatrix);
  C = ((Number*)scratch);
  program = (int*)0x01000000;

#ifdef MURALI
  int number_stores = (size / 16) * (size / 16) ;
#endif 

#ifdef MYRON
  int number_stores = (size / 64) * (size / 64);
#endif

  int stores_received = 0;

  initialize();
  
  for(i=0; i < size * size; i++)
  {
    *(A+i) = complexRandom();   
  }
  
  for(i=0; i < size * size; i++)
  {
    *(B+i) = complexRandom();   
  } 

  for(i=0; i < size * size; i++)
  {
    *(C+i) = 0;   
  }   
  
  for(i=0; i < size * size; i++)
  {
    *(ours+i) = 0;   
  } 

  print("in main \r\n");
  if(size < 512)
  {
    mmm(A,B,C,size);
  }
  
  for(i=0; i < 16; i++)
  {  
     xil_printf("first data: %x, second data: %x, result: %x\r\n", *(A+i), *(B+i), *(C+i));
  }
  //print("after init\r\n");
  
  i = 0;
  
  
 #ifdef MYRON 
start=ts_get_ll(); 
// while(1)
//  {
     //print("loop\r\n");
/*
     int response;
     if(i < sizeof(algo)/sizeof(UInt64))//i is number of 2-elem slots/
	  {
	     
		  if(putInstruction(algo[2*i], algo[2*i + 1]) >= 0)
		  {
			  //print("add\r\n");	
		     //xil_printf("Add %x:%x\r\n",algo[2*i],algo[2*i+1]);
			  i++;
    
		  }
		  else
		  {
		     print("Failed inst\r\n");
		  }
	  }
	  
	  response = getResponse();
	  if(response >= 0)
	  {
	     if(response == 0)
		  {
		     print("Beat\r\n");
		  }
		  else
		  {
		    stores_received++;
			 if (stores_received == number_stores) break;		    
		  }
	  } 
 }
 */
multiplyFunction64(program, size, log_size);  
finish=ts_get_ll();  
#endif  
 

#ifdef MURALI 
  start=ts_get_ll();
  multiplyFunction(size,log_size);
  finish=ts_get_ll();
#endif
	
  xil_printf("time: %d\r\n", ts_elapse_us(start,finish));
  xil_printf("matching\r\n");
  for(i = 0; i < size * size; i++)
  {
     if(absDiff(ours[i],C[i]) > 0x000F)
	  {
	     xil_printf("Mismatch[%d]: expected: %x received: %x %x \n\r", i, C[i], ours[i], absDiff(C[i],ours[i]));
		  break;
	  }
	  //else 
	  //{
	      //xil_printf("Match[%d]: expected: %x received: %x\n\r", i, C[i], ours[i]);
	  //}
	 
  }
  xil_printf("NIRAV, MYRON, AND MICHAEL WIN!\r\n");
  //for(i=0; i < 16; i++)
  //{  
  //   xil_printf("our data: %x\r\n", *(ours+i));
  //}
}

