signature Types where {
import Clocks;
		
import Environment;
		     
import FIFOF_;
		
import FIFOF;
	       
import FIFO;
	      
import FixedPoint;
		    
import List;
	      
import ListN;
	       
import Parameters;
		 
import PrimArray;
		   
import Vector;
		
import Complex16;
		
import Connectable;
		     
import GetPut;
		
type (Types.ComplexWord :: *) = Complex16.Complex16;
						   
data (Types.MatrixRegister :: *) = Types.A () | Types.B () | Types.C ();
								       
instance Types Prelude.Bits Types.MatrixRegister 2;
							
instance Types Prelude.Eq Types.MatrixRegister;
						    
data (Types.FunctionalUnitOp :: *) =
    Types.Multiply () |
    Types.Zero () |
    Types.MultiplyAddAccumulate () |
    Types.MultiplySubAccumulate () |
    Types.AddAccumulate () |
    Types.SubAccumulate ();
			  
instance Types Prelude.Bits Types.FunctionalUnitOp 3;
							  
instance Types Prelude.Eq Types.FunctionalUnitOp;
						      
data (Types.PLBMasterCommand :: *) =
    Types.RowSize (Prelude.Bit Parameters.LogRowSize) |
    Types.LoadPage Parameters.BlockAddr |
    Types.StorePage Parameters.BlockAddr;
					
instance Types Prelude.Bits Types.PLBMasterCommand 32;
							   
instance Types Prelude.Eq Types.PLBMasterCommand;
						      
data (Types.MemorySwitchCommand :: *) =
    Types.StoreFromFU Parameters.FunctionalUnitAddr | Types.LoadToFUs Parameters.FunctionalUnitMask;
												   
instance Types Prelude.Bits Types.MemorySwitchCommand 2;
							     
instance Types Prelude.Eq Types.MemorySwitchCommand;
							 
struct (Types.FUNetworkCommand :: *) = {
    Types.fuSrc :: Parameters.FunctionalUnitAddr;
    Types.regSrc :: Types.MatrixRegister;
    Types.fuDests :: Parameters.FunctionalUnitMask;
    Types.regDest :: Types.MatrixRegister
};
 
instance Types Prelude.Bits Types.FUNetworkCommand 5;
							  
instance Types Prelude.Eq Types.FUNetworkCommand;
						      
data (Types.FunctionalUnitCommand :: *) =
    Types.ForwardSrc Types.MatrixRegister |
    Types.ForwardDest Types.MatrixRegister |
    Types.Load Types.MatrixRegister |
    Types.Store Types.MatrixRegister |
    Types.Op Types.FunctionalUnitOp;
				   
instance Types Prelude.Bits Types.FunctionalUnitCommand 6;
							       
instance Types Prelude.Eq Types.FunctionalUnitCommand;
							   
data (Types.Instruction :: *) =
    Types.ArithmeticInstruction Types.Instruction\xb0\x41rithmeticInstruction |
    Types.LoadInstruction Types.Instruction\xb0LoadInstruction |
    Types.StoreInstruction Types.Instruction\xb0StoreInstruction |
    Types.ForwardInstruction Types.Instruction\xb0\x46orwardInstruction |
    Types.SetRowSizeInstruction (Prelude.Bit Parameters.LogRowSize);
									 
instance Types Prelude.Bits Types.Instruction 38;
						      
instance Types Prelude.Eq Types.Instruction;
						 
struct (Types.Instruction\xb0\x41rithmeticInstruction :: *) = {
    Types.fus :: Parameters.FunctionalUnitMask;
    Types.op :: Types.FunctionalUnitOp
};
 
instance Types Prelude.Bits Types.Instruction\xb0\x41rithmeticInstruction 4;
										   
instance Types Prelude.Eq Types.Instruction\xb0\x41rithmeticInstruction;
									       
struct (Types.Instruction\xb0LoadInstruction :: *) = {
    Types.fus :: Parameters.FunctionalUnitMask;
    Types.regName :: Types.MatrixRegister;
    Types.addr :: Parameters.PLBAddr
};
 
instance Types Prelude.Bits Types.Instruction\xb0LoadInstruction 35;
									   
instance Types Prelude.Eq Types.Instruction\xb0LoadInstruction;
								      
struct (Types.Instruction\xb0StoreInstruction :: *) = {
    Types.fu :: Parameters.FunctionalUnitAddr;
    Types.regName :: Types.MatrixRegister;
    Types.addr :: Parameters.PLBAddr
};
 
instance Types Prelude.Bits Types.Instruction\xb0StoreInstruction 34;
									    
instance Types Prelude.Eq Types.Instruction\xb0StoreInstruction;
								       
struct (Types.Instruction\xb0\x46orwardInstruction :: *) = {
    Types.fuSrc :: Parameters.FunctionalUnitAddr;
    Types.regSrc :: Types.MatrixRegister;
    Types.fuDests :: Parameters.FunctionalUnitMask;
    Types.regDest :: Types.MatrixRegister
};
 
instance Types Prelude.Bits Types.Instruction\xb0\x46orwardInstruction 5;
										
instance Types Prelude.Eq Types.Instruction\xb0\x46orwardInstruction;
									    
type (Types.PPCMessage :: *) = Prelude.Bit 32;
						   
data (Types.FeederState :: *) =
    Types.FI_InStartCheckRead () |
    Types.FI_InStartRead () |
    Types.FI_InStartTake () |
    Types.FI_OutStartCheckWrite () |
    Types.FI_OutStartWrite () |
    Types.FI_OutStartPush () |
    Types.FI_CheckLoadStore () |
    Types.FI_Load () |
    Types.FI_LoadTake () |
    Types.FI_Store () |
    Types.FI_StorePush ();
			 
instance Types Prelude.Eq Types.FeederState;
						 
instance Types Prelude.Bits Types.FeederState 4;
						     
Types.translateLoad :: Types.Instruction -> Prelude.Maybe Parameters.BlockAddr;
										    
Types.translateStore :: Types.Instruction -> Prelude.Maybe Parameters.BlockAddr;
										     
Types.translateRowSize :: Types.Instruction -> Prelude.Maybe Parameters.BlockAddr;
										       
instance FixedPoint Prelude.Eq (FixedPoint.FixedPoint isize fsize);
										       
instance FixedPoint Prelude.Bits (FixedPoint.FixedPoint isize fsize)
		       (Prelude.TAdd isize fsize);
							     
instance FixedPoint (Prelude.Add 1 xxx i) =>
		       Prelude.Bounded (FixedPoint.FixedPoint i f);
										    
instance FixedPoint (Prelude.Add i f (Prelude.TAdd i f),
			Prelude.Add 1 xxx i) =>
		       Prelude.Arith (FixedPoint.FixedPoint i f);
										  
instance FixedPoint (Prelude.Add 1 xxx i,
			Prelude.Add i f (Prelude.TAdd i f)) =>
		       Prelude.Literal (FixedPoint.FixedPoint i f);
										    
instance FixedPoint (Prelude.Add 1 xxx i) =>
		       Prelude.Ord (FixedPoint.FixedPoint i f);
										
instance FixedPoint (Prelude.Add 1 xxx i) =>
		       Prelude.Bitwise (FixedPoint.FixedPoint i f);
										    
instance ListN (Prelude.Eq (Prelude.List a)) =>
		  Prelude.Eq (ListN.ListN n a);
								
instance ListN (Prelude.Bits a sa, Prelude.Mul n sa nsa) =>
		  Prelude.Bits (ListN.ListN n a) nsa;
									 
instance ListN Prelude.PrimSelectable (ListN.ListN n a) a;
										 
instance ListN Prelude.PrimUpdateable (ListN.ListN n a) a;
										 
instance Vector (Prelude.Eq (Prelude.PrimArray a)) =>
		   Prelude.Eq (Vector.Vector n a);
								   
instance Vector (Prelude.Bits a sa, Prelude.Mul n sa nsa) =>
		   Prelude.Bits (Vector.Vector n a) nsa;
									    
instance Vector (Prelude.Bounded a, Prelude.Bits a sa) =>
		   Prelude.Bounded (Vector.Vector n a);
									
instance Vector Prelude.PrimSelectable (Vector.Vector n a) a;
										    
instance Vector Prelude.PrimUpdateable (Vector.Vector n a) a;
										    
instance Complex16 Prelude.Eq Complex16.Complex16;
						       
instance Complex16 Prelude.Bits Complex16.Complex16 32;
							    
instance Complex16 Prelude.Literal Complex16.Complex16;
							    
instance Complex16 Prelude.Bounded Complex16.Complex16;
							    
instance Complex16 Prelude.Arith Complex16.Complex16;
							  
instance Connectable (Connectable.Connectable a b,
			 Connectable.Connectable c d) =>
			Connectable.Connectable (a, c) (b, d);
									       
instance Connectable (Connectable.Connectable a b) =>
			Connectable.Connectable (Vector.Vector n a) (Vector.Vector n b);
														     
instance Connectable (Connectable.Connectable a b) =>
			Connectable.Connectable (ListN.ListN n a) (ListN.ListN n b);
														 
instance Connectable Connectable.Connectable (PreludeBSV.RWire a)
			(PreludeBSV.RWire a);
						     
instance Connectable Connectable.Connectable (Prelude.ActionValue a)
			(a -> Prelude.Action);
						      
instance Connectable Connectable.Connectable (a -> Prelude.Action)
			(Prelude.ActionValue a);
							
instance GetPut Connectable.Connectable (GetPut.Get a) (GetPut.Put a);
												
instance GetPut Connectable.Connectable (GetPut.Put a) (GetPut.Get a);
												
instance GetPut (Prelude.Bits a sa) =>
		   Prelude.ClockConv (GetPut.Get a);
								  
instance GetPut (Prelude.Bits a sa) =>
		   Prelude.ClockConv (GetPut.Put a);
								  
type (Complex16.Complex16 :: *);
			       
class (Connectable.Connectable :: * -> * -> *) a b | a -> b, b -> a;
									 
type (FixedPoint.FixedPoint :: # -> # -> *) _v100 _v101;
							     
type (GetPut.Get :: * -> *) _v100;
				       
type (GetPut.Put :: * -> *) _v100;
				       
type (ListN.ListN :: # -> * -> *) _v100 _v101;
						   
type (Parameters.BlockAddr :: *);
				
type (Parameters.FunctionalUnitAddr :: *);
					 
type (Parameters.FunctionalUnitMask :: *);
					 
type (Parameters.LogRowSize :: #);
				 
type (Parameters.PLBAddr :: *);
			      
type (Vector.Vector :: # -> * -> *) _v100 _v101
}
