typedef 2 FuncUnitNumSz;
typedef Bit#(FuncUnitNumSz) FuncUnitNum;
typedef Bit#(13) RowSize;

typedef enum {A, B, C} MatrixRegister deriving (Bits, Eq);

typedef struct {
    FuncUnitNum    fuNum;
    MatrixRegister regName;
    DramAddr       addr;
} MemoryInst deriving (Bits, Eq);

typedef struct {
    MatrixRegister regSrc;
    FuncUnitNum    fuSrc;
    MatrixRegister regDest;
    FuncUnitNum    fuDest;
} ForwardInst deriving (Bits, Eq);

typedef union tagged {
    ForwardInst Forward;
    MemoryInst  Load;
    MemoryInst  Store;
    RowSize     SetRowSize;
    void        Multiply;
    void        SetZero;
    void        Add;
    void        Subtract;
    void        MultiplyAccumulate;
    void        AddAccumulate;
} Inst deriving (Bits, Eq);
