
// Global imports
import Clocks::*;

 
// Local imports
import Parameters::*;
import Types::*;
import Interfaces::*;
import Multiplier::*;
import PLBMasterWires::*;
import BRAMTargetWires::*;
import PPCModel::*;
import PLBModel::*; 
import BRAMModel::*; 

module mkSystemSimulator();
  Clock fpga_clock <- exposeCurrentClock();
  Reset fpga_reset <- exposeCurrentReset();

  Multiplier  multiplier <- mkMultiplierTop;                                      

  PPC ppc <- mkPPCModel();
  
  Empty bram_between_ppc_and_feeder <- 
      mkBRAMModel(fpga_clock, fpga_reset,fpga_clock, fpga_reset, ppc.bramInitiatorWires, multiplier.bramInitiatorWires);



  Empty  plb  <- mkPLBModel(multiplier.plbMasterWires);                              


endmodule
