// Global imports
import Clocks::*;

// Local imports
import Types::*;
import Interfaces::*;
import MultiplierBackup::*;
import PLBMasterWires::*;
import BRAMTargetWires::*;
import PPCModel::*;
import PLBMaster_backupPPC::*; 
import BRAMModel::*; 
import BRAMInitiatorWires::*;
import PLBMasterWires::*;

module mkSystemSimulatorBackup();
  Clock fpgaClock <- exposeCurrentClock;
  Reset fpgaReset <- exposeCurrentReset;
  
  Clock plbClock <- mkAbsoluteClock(3, 3);
  Reset plbReset <- mkInitialReset(1, clocked_by plbClock);   

  MultiplierBackup  multiplier <- mkMultiplierBackupTop;

  PPC ppc <- mkPPCModel();
  BRAMInitiatorWires#(Bit#(14)) plb  <- mkPLB_backupPPC();  

  Empty bram_between_ppc_and_feeder <- 
      mkBRAMModel(fpgaClock, fpgaReset, fpgaClock, fpgaReset, ppc.bramInitiatorWires, multiplier.bramInitiatorWires);

  Empty bram_between_ppc_and_plb <- 
      mkBRAMModel(fpgaClock, fpgaReset, fpgaClock, fpgaReset, plb, multiplier.plbBRAMWires);



endmodule
