#include "instructions.h"
#include "instructionParameters.h"
#include "matrixPointers.h"
#include "cLib.h"

#define createSec(m, i, j, x) \
            (m + i*BlockSize*Size*4 + (FU_Number*j+x)*BlockSize*4)

#define createPrim(m, i, j) \
            (m + i*BlockSize*Size*4 + j*BlockSize*4)

void goodAlgo()
{
  //int Size = 64;
  int Size = 128;
    int BlockSize = 64;
    UInt64 a = (UInt64)aMatrix;
    UInt64 b = (UInt64)bMatrix;
    UInt64 c = (UInt64)cMatrix;

    int FU_Number = (int) FunctionalUnitNumber;

    int BlockNum = Size/BlockSize;
    int LogSize;

    int BigBlockNum = BlockNum/FU_Number;
    int BigBlockRest = BlockNum%FU_Number;

    int response;

    UInt64 inst;    

    switch(Size)
    {
        case 64:
            LogSize = 6;
            break;
        case 128:
            LogSize = 7;
            break;
        case 256:
            LogSize = 8;
            break;
        case 512:
            LogSize = 9;
            break;
        default:
            LogSize = 10;
            break;
    }

    inst = createSetRowSizeInstruction(LogSize);  

    while(putInstruction((inst >> 32) & 0xffffffff,inst & 0xffffffff ) < 0)
      {
      } 

    int i;
    int j;
    int k;
    int f;

    for(i = 0; i < BlockNum; i=i+1)
    {
        for(j = 0; j < BigBlockNum; j=j+1)
        {
	    inst = createArithmeticInstruction(All_FU_Mask, Zero);
            while(putInstruction((inst >> 32) & 0xffffffff,inst & 0xffffffff ) < 0);
            for(k = 0; k < BlockNum; k=k+1)
            {
                for(f = 0; f < FU_Number; f=f+1)
                {
		   inst = putInstruction(createLoadInstruction((((int)1)<<f), B, createSec(b, k, j, f)); 
		   while(putInstruction((inst >> 32) & 0xffffffff,inst & 0xffffffff) < 0)
		   { 

		   }
                }
		   inst = createLoadInstruction(All_FU_Mask, A, createPrim(a, i, k));
                while(putInstruction(inst >> 32) & 0xffffffff,inst & 0xffffffff() < 0)
		{ 

                }
  
                inst = createArithmeticInstruction(All_FU_Mask, MultiplyAddAccumulate); 
                while(putInstruction((inst >> 32) & 0xffffffff,inst & 0xffffffff) < 0)
		{

		}
            }
            for(f = 0; f < FU_Number; f=f+1)
            {
              int i = 0;
              inst = createStoreInstruction(f, C, createSec(c, i, j, f));
	      while(putInstruction((inst >> 32) & 0xffffffff,inst & 0xffffffff) < 0);
              {
              }
 
              while(getResponse((inst >> 32) & 0xffffffff,inst & 0xffffffff) >= 0)
                {
                  i++;
                  if(i == 300000000)
		    {      
		      xil_printf(" Uhoh were hanging \r\n");
		    }		 
                } 

            }
        }
        if(BigBlockRest != 0)
        {
	  inst = createArithmeticInstruction(All_FU_Mask, Zero);
	    while(putInstruction((inst >> 32) & 0xffffffff,inst & 0xffffffff) < 0)
	    {

	    } 

            for(k = 0; k < BlockNum; k=k+1)
            {
                for(f = 0; f < BigBlockRest; f=f+1)
                {
                  inst = createLoadInstruction(((int)1<<f), B, createPrim(b, k, j*FU_Number+f));
		  while(putInstruction(inst >> 32) & 0xffffffff,inst & 0xffffffff() < 0)
		    {

                    } 
 
                }

                inst = createLoadInstruction(All_FU_Mask, A, createPrim(a, i, k));
                while(putInstruction((inst >> 32) & 0xffffffff,inst & 0xffffffff) < 0)
                {

                }

                inst = createArithmeticInstruction(All_FU_Mask, MultiplyAddAccumulate);
                while(putInstruction((inst >> 32) & 0xffffffff,inst & 0xffffffff()) < 0)
		{

		}
            }
            for(f = 0; f < BigBlockRest; f=f+1)
            {
              int i = 0;
              inst = createStoreInstruction(f, C, createPrim(c, i, j*FU_Number+f));
	      while(putInstruction((inst >> 32) & 0xffffffff,inst & 0xffffffff) < 0)
		{
                  
		}

              while(getResponse =< 0)
                {
                  i++;
                  if(i == 300000000)
		    {      
		      xil_printf(" Uhoh were hanging \r\n");
		    }		 
                }         

            }
        }
    }
}
